library(MLmetrics)
errors = function( y_pred_train , y_pred_test , 
                   y_train, y_test){
  # y_pred_train : vector of predictions on train
  # y_pred_test :
  # y_train 
  # y_test :
  if (length(y_pred_train)!=length(y_train)){
    print("y_pred_train and y_train do not have the same length")
  }
  logMSE_train = mean( ( log(y_train + 1) - log(y_pred_train + 1)  )^2 ,
                       na.rm = T)
  logMSE_test = mean( (log(y_test+1) - log(y_pred_test+1) )^2,
                      na.rm = T)
  MAPE_train = mean( abs(y_train - y_pred_train)/(y_train+1),
                     na.rm = T)
  MAPE_test = mean( abs(y_test - y_pred_test)/(y_test+1),
                    na.rm = T)
  return( list(logMSE_train=logMSE_train,logMSE_test=logMSE_test,
               MAPE_train= MAPE_train,MAPE_test= MAPE_test))
}

sigmoid = function(x){
  sigmoid = exp(x)/(1/exp(x))
}


predictions_scores_hurdle = function(model_classif , model_hurdle , data_small_train = claims_small_train,
                                     data_small_test = claims_small_test,seuil = 0.5){
  y_true_train = pull(data_small_train,ClaimNb)
  y_true_test = pull(data_small_test,ClaimNb)
  
  y_pred_classif_train = predict(model_classif,type="response")
  y_pred_couchehurdle_train = predict(model_hurdle,data_small_train,type="response") + 1
  y_pred_hurdle_train = y_pred_classif_train * y_pred_couchehurdle_train
  y_pred_hurdle_train01 = (y_pred_classif_train>seuil) * y_pred_couchehurdle_train
  
  
  y_pred_classif_test = predict(model_classif,data_small_test,type="response")
  y_pred_couchehurdle_test = predict(model_hurdle,data_small_test,type="response") + 1
  y_pred_hurdle_test = y_pred_classif_test * y_pred_couchehurdle_test
  y_pred_hurdle_test01 = (y_pred_classif_test>seuil) * y_pred_couchehurdle_test
  
  errors_hurdle = errors(y_pred_hurdle_train,y_pred_hurdle_test,y_true_train,y_true_test)
  errors_hurdle01 = errors(y_pred_hurdle_train01,y_pred_hurdle_test01,y_true_train,y_true_test)
  
  
  return(list(prediction_train =  y_pred_hurdle_train,prediction_train01 = y_pred_hurdle_train01,
              prediction_test =  y_pred_hurdle_test,prediction_test01 = y_pred_hurdle_test01,
              errors_hurdle = errors_hurdle,
              errors_hurdle01 = errors_hurdle01))
}